(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("React"));
	else if(typeof define === 'function' && define.amd)
		define(["React"], factory);
	else if(typeof exports === 'object')
		exports["ReactCluster"] = factory(require("React"));
	else
		root["ReactCluster"] = factory(root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_2__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = __webpack_require__(1);

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	exports.visibleRows = visibleRows;
	exports.paddedRange = paddedRange;
	exports.inRange = inRange;

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _function = __webpack_require__(3);

	var _function2 = _interopRequireDefault(_function);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	/**
	 * Defaults.
	 */

	/**
	 * Types.
	 */

	var INITIAL_STATE = {
	  index: 0
	};

	/**
	 * Cluster component.
	 *
	 * Displays large sets of data in a scroll container.
	 */

	var Cluster = function (_React$Component) {
	  _inherits(Cluster, _React$Component);

	  function Cluster(props) {
	    _classCallCheck(this, Cluster);

	    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Cluster).call(this, props));

	    _this.state = INITIAL_STATE;
	    _this.shouldComponentUpdate = _function2.default;


	    _this.scrollHandler = _this.scrollHandler.bind(_this);
	    return _this;
	  }

	  _createClass(Cluster, [{
	    key: 'render',
	    value: function render() {
	      var _props = this.props;
	      var className = _props.className;
	      var height = _props.height;


	      var style = {
	        height: height,
	        overflow: 'scroll'
	      };

	      return _react2.default.createElement(
	        'div',
	        { className: className, onScroll: this.scrollHandler, style: style },
	        this.renderRows()
	      );
	    }

	    /**
	     * Wrap each child in a fixed height container and conditionally
	     * render the child.
	     */

	  }, {
	    key: 'renderRows',
	    value: function renderRows() {
	      var _props2 = this.props;
	      var children = _props2.children;
	      var rowHeight = _props2.rowHeight;


	      var range = this.currentRange();

	      var style = {
	        height: rowHeight
	      };

	      return children.map(function (child, index) {
	        return _react2.default.createElement(
	          'div',
	          { key: index, style: style },
	          inRange(index, range) ? child : null
	        );
	      });
	    }
	  }, {
	    key: 'scrollHandler',
	    value: function scrollHandler(event) {
	      var index = this.currentIndex(event.target);
	      var _props3 = this.props;
	      var onIndexChange = _props3.onIndexChange;
	      var onScrollChange = _props3.onScrollChange;
	      var onScrollEnd = _props3.onScrollEnd;


	      if (index !== this.state.index) {
	        this.setState({ index: index });

	        if (onIndexChange) {
	          onIndexChange(index);
	        }

	        if (onScrollEnd && this.scrolledNearEnd(event.target)) {
	          onScrollEnd();
	        }
	      }

	      if (onScrollChange) {
	        onScrollChange(event.target);
	      }
	    }
	  }, {
	    key: 'currentIndex',
	    value: function currentIndex(cluster) {
	      var rowHeight = this.props.rowHeight;


	      return Math.floor(cluster.scrollTop / rowHeight);
	    }
	  }, {
	    key: 'scrolledNearEnd',
	    value: function scrolledNearEnd(_ref) {
	      var scrollHeight = _ref.scrollHeight;
	      var scrollTop = _ref.scrollTop;
	      var height = this.props.height;


	      return scrollHeight - scrollTop <= height * 2;
	    }
	  }, {
	    key: 'currentRange',
	    value: function currentRange() {
	      var start = this.state.index;
	      var end = start + visibleRows(this.props);

	      return paddedRange({ start: start, end: end });
	    }
	  }]);

	  return Cluster;
	}(_react2.default.Component);

	/**
	 * Return the number of visible rows inside the scrollable container.
	 */

	exports.default = Cluster;
	function visibleRows(_ref2) {
	  var height = _ref2.height;
	  var rowHeight = _ref2.rowHeight;

	  return Math.ceil(height / rowHeight);
	}

	/**
	 * Return a padded range.
	 */

	function paddedRange(_ref3) {
	  var start = _ref3.start;
	  var end = _ref3.end;

	  var padding = Math.ceil((end - start) / 2);

	  return {
	    start: start - padding,
	    end: end + padding
	  };
	}

	/**
	 * Return true if value is in range.
	 */

	function inRange(value, _ref4) {
	  var start = _ref4.start;
	  var end = _ref4.end;

	  return value >= start && value <= end;
	}

/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports['default'] = shouldPureComponentUpdate;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _shallowEqual = __webpack_require__(4);

	var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

	function shouldPureComponentUpdate(nextProps, nextState) {
	  return !(0, _shallowEqual2['default'])(this.props, nextProps) || !(0, _shallowEqual2['default'])(this.state, nextState);
	}

	module.exports = exports['default'];

/***/ },
/* 4 */
/***/ function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports['default'] = shallowEqual;

	function shallowEqual(objA, objB) {
	  if (objA === objB) {
	    return true;
	  }

	  if (typeof objA !== 'object' || objA === null || typeof objB !== 'object' || objB === null) {
	    return false;
	  }

	  var keysA = Object.keys(objA);
	  var keysB = Object.keys(objB);

	  if (keysA.length !== keysB.length) {
	    return false;
	  }

	  // Test for A's keys different from B.
	  var bHasOwnProperty = Object.prototype.hasOwnProperty.bind(objB);
	  for (var i = 0; i < keysA.length; i++) {
	    if (!bHasOwnProperty(keysA[i]) || objA[keysA[i]] !== objB[keysA[i]]) {
	      return false;
	    }
	  }

	  return true;
	}

	module.exports = exports['default'];

/***/ }
/******/ ])
});
;